Bug 24743 - avr-gcc не находит библиотек и стабов
: avr-gcc не находит библиотек и стабов
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/avr-gcc)
: unstable
: all Linux
: P3 normal
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2010-12-12 00:32 by
Modified: 2011-01-18 13:32 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2010-12-12 00:32:29
Что-то у меня перестал собираться код с помощью avr-gcc

[sin@base test]$ make

-------- begin --------
avr-gcc (GCC) 4.5.1
Copyright (C) 2010 Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.


Linking: main.elf
avr-g++ -mmcu=at90s8535 -I. -gstabs   -Os -funsigned-char -funsigned-bitfields
-fpack-struct -fshort-enums -Wa,-adhlns=main.o -I../../include
-I/usr/lib/avr/include -DF_OSC=16000000 -Wall -MD -MP -MF .dep/main.elf.d
main.o   --output main.elf -Wl,-Map=main.map,--cref    -lm
/usr/bin/avr-ld: cannot find crts8535.o: No such file or directory
/usr/bin/avr-ld: cannot find -lm
/usr/bin/avr-ld: cannot find -lc
collect2: ld returned 1 exit status
make: *** [main.elf] Ошибка 1
[sin@base test]$ rpm -q --lastchange avr-gcc
* Срд Ноя 03 2010 Grigory Milev <week@altlinux.ru> 4.5.1-alt1
- new version released
- gcc moved to /usr/lib/gcc/avr and /usr/lib/libexec/gcc/avr
[sin@base test]$ ls -l /usr/lib/avr/crts8535.o
-rw-r--r-- 1 root root 4012 Ноя  5 17:43 /usr/lib/avr/crts8535.o
[sin@base test]$ rpm -qf /usr/lib/avr/crts8535.o
avr-libc-1.7.0-alt1
------- Comment #1 From 2011-01-07 19:28:45 -------
для сборки попробуйте добавить опцию
-B/usr/lib/avr

что показывает
avr-g++ -print-search-dirs 

?
------- Comment #2 From 2011-01-09 02:42:23 -------
(В ответ на комментарий №1)
> для сборки попробуйте добавить опцию
> -B/usr/lib/avr
> 

Да, так срабатывает, спасибо... Хотя, конечно, не хотелось бы эту специфичную к
текущей сборке строку прописывать в разных проектах.

> что показывает
> avr-g++ -print-search-dirs 
> 
> ?

Для не рабочей 4.5.1:
$ avr-g++ -print-search-dirs
install: /usr/lib/gcc/avr/4.5.1/
programs:
=/usr/libexec/gcc/avr/4.5.1/:/usr/libexec/gcc/avr/4.5.1/:/usr/libexec/gcc/avr/:/usr/lib/gcc/avr/4.5.1/:/usr/lib/gcc/avr/:/usr/lib/gcc/avr/4.5.1/../../../../avr/bin/avr/4.5.1/:/usr/lib/gcc/avr/4.5.1/../../../../avr/bin/
libraries:
=/usr/lib/gcc/avr/4.5.1/:/usr/lib/gcc/avr/4.5.1/../../../../avr/lib/avr/4.5.1/:/usr/lib/gcc/avr/4.5.1/../../../../avr/lib/

Для старой рабочей версии так:
$ avr-g++ -print-search-dirs
install: /usr/lib/avr/lib/gcc/avr/4.2.2/
programs:
=/usr/bin/../../gcc/avr/4.2.2/:/usr/bin/../../gcc/:/usr/lib/gcc/avr/4.2.2/:/usr/lib/gcc/avr/4.2.2/:/usr/lib/gcc/avr/:/usr/lib/avr/lib/gcc/avr/4.2.2/:/usr/lib/avr/lib/gcc/avr/:/usr/libexec/gcc/avr/4.2.2/:/usr/libexec/gcc/avr/:/usr/lib/gcc/avr/4.2.2/:/usr/lib/gcc/avr/:/usr/bin/../lib/gcc/avr/4.2.2/../../../../avr/bin/avr/4.2.2/:/usr/bin/../lib/gcc/avr/4.2.2/../../../../avr/bin/:/usr/lib/avr/lib/gcc/avr/4.2.2/../../../../avr/bin/avr/4.2.2/:/usr/lib/avr/lib/gcc/avr/4.2.2/../../../../avr/bin/
libraries:
=/usr/bin/../lib/gcc/avr/4.2.2/:/usr/bin/../lib/gcc/:/usr/lib/avr/lib/gcc/avr/4.2.2/:/usr/lib/gcc/avr/4.2.2/:/usr/bin/../lib/gcc/avr/4.2.2/../../../../avr/lib/avr/4.2.2/:/usr/bin/../lib/gcc/avr/4.2.2/../../../../avr/lib/:/usr/lib/avr/lib/gcc/avr/4.2.2/../../../../avr/lib/avr/4.2.2/:/usr/lib/avr/lib/gcc/avr/4.2.2/../../../../avr/lib/
------- Comment #3 From 2011-01-13 18:00:55 -------
В сизиф отправлено на пересборку:

avr-binutils-2.21-alt1.src.rpm
avr-gcc-4.5.1-alt2.src.rpm
avr-libc-1.7.0-alt2.src.rpm

Исправлены пути, убран лишний патч из binutils + обновлен binutils до последней
версии.

Тестируйте, если что не так, постараюсь сразу исправить.
------- Comment #4 From 2011-01-13 18:01:39 -------
Считаю баг закрытым.